-- name: migration-0000-create-files#
CREATE TABLE IF NOT EXISTS files (
   id INTEGER PRIMARY KEY AUTOINCREMENT
 , user_id INTEGER
 , filename TEXT
 , path TEXT
 , upload_date TEXT
 , FOREIGN KEY(user_id) REFERENCES user(id)
);

-- name: create-file^
INSERT INTO files (
   user_id
 , filename
 , path
 , upload_date
)
VALUES (:uid, :filename, :path , datetime('now'))
RETURNING
   id
;

-- name: list-files
SELECT
   *
 , (SELECT COUNT(*) FROM jobs WHERE file_id = f.id AND status_id > 1) AS `print_successes`
 , (SELECT COUNT(*) FROM jobs WHERE file_id = f.id AND status_id < 0) AS `print_failures`
FROM files f
WHERE
   user_id = :uid
;

-- name: delete-file!
DELETE FROM files
WHERE
   user_id = :uid
   AND id = :fid
;

-- name: fetch-file^
SELECT
   *
FROM files
WHERE
   user_id = :uid
   AND id = :fid
;
